Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 451898 - Use the alternatives system to handle the link to the firefox executable
Summary: Use the alternatives system to handle the link to the firefox executable
Keywords:
Status: CLOSED NOTABUG
Alias: None
Product: Fedora
Classification: Fedora
Component: firefox
Version: 9
Hardware: All
OS: Linux
low
low
Target Milestone: ---
Assignee: Gecko Maintainer
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2008-06-18 01:08 UTC by George Notaras
Modified: 2018-04-11 15:38 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2008-06-18 20:15:42 UTC


Attachments (Terms of Use)

Description George Notaras 2008-06-18 01:08:49 UTC
This is not actually a bug report, but an enhancement request.

At the moment, users are somehow tied to use the default firefox version that
comes with fedora, which usually is old. There is no easy way to switch to a
version downloaded from mozilla.org without having to modify the paths in the
various launchers, menu entries, "prefered applications" preferences etc.

I think that a more generic link, like /usr/bin/web-browser, should be used and
have the alternatives system handle the symlinks to the actual application
executables, like it happens with some cli text editors.

This will make life easier for those who want to use a firefox version other
than the one supplied by fedora as the system default. I don't think it will
cause any confusion or any other kind of problem to the rest of the users.

Comment 1 Matěj Cepl 2008-06-18 20:15:42 UTC
This is soundly NOTABUG. Read update-alternatives(8), use its option --install
and do whatever you want to do with it.

Comment 2 George Notaras 2008-06-19 00:26:56 UTC
First of all, if you read my initial message, you will see that this was
reported as a feature request and not as a bug.

I already use the alternatives system and I even have documented what a user
currently needs to do in order to switch (system-wide) to a custom firefox
release in this tutorial:
http://www.g-loaded.eu/2008/06/18/use-the-alternatives-system-to-switch-to-a-custom-firefox-release/

Just in case I had not expressed myself correctly in the previous message, I
rephrase my request: It would be more convenient for the end user if fedora
already provided the firefox executable through the alternatives system and not
force the user to configure the "firefox alternatives" from scratch in order to
use a custom firefox version (which is probably what the majority of the fedora
users want).

What causes some trouble when the user tries to configure the alternatives for
firefox is the fact that the path '/usr/bin/firefox' is already occupied by the
firefox launcher script. This of course can be overridden by making the
alternatives system create the master firefox link in /usr/local/bin/, but, in
my opinion, this adds unnecessary complexity to what should be a simple task.

To sum it up, I suggest that:

 * The firefox launcher script (/usr/bin/firefox) should be renamed during the
RPM creation process to something else, for example: /usr/bin/firefox.fedora
 * The symbolic link '/usr/bin/firefox' should be created by the alternatives
system and should initially point to /usr/bin/firefox.fedora

By making the above simple modifications, what an end-user, who wishes to use a
custom firefox build, needs to do is simply add the path to the custom firefox
executable as a second alternative and switch to it. For instance:

  /usr/sbin/alternatives --install /usr/bin/firefox firefox
/opt/customff/firefox 100
  /usr/sbin/alternatives --set firefox /opt/customff/firefox

In the previous post I mentioned a more generic name for the link to the browser
executable (/usr/bin/web-browser), but, after a second thought, I guess it is
unnecessary. '/usr/bin/firefox' is just fine.

So, if you have _soundly_ closed the bug as invalid, I soundly say that you
should give it a second thought. The suggested modifications will not cause any
problems to fedora. The benefits of these modifications will be obvious if you
try to configure a fedora system to use a custom firefox version through the
alternatives system.

Finally, I repeat that I have resolved my problem, I have documented the
workaround so that others can use it to resolve their similar problems and I
have voluntarily spent my time to report my suggestions here.

I think I have done my part 100% regarding this issue.


Comment 3 Matěj Cepl 2008-06-19 20:09:22 UTC
Sorry, about that "soundly", I should make myself more clear why I thought (and
I still think) this shouldn't be made part of Fedora itself.

First of all, update-alternatives in Fedora (and in Debian as well, where this
whole concept originates from) is meant for two different Fedora packages
providing the same functionality (e.g., firefox, galeon, and epiphany are proper
candidates for this). There doesn't seem to be much legitimate reason why to use
upstream binary for normal user (i.e., only so sick souls as me who need to test
obscure features) and quite certainly use of the upstream binary is not
supported as normal operation on Fedora (moreover, with inclusion of
nspluginwrapper and making it confined by SELinux, upstream binary doesn't work
in many situations where our firefox just works).

Second, frankly, based on our experience with our users, I don't believe there
are that many users who would use both our and upstream binary of firefox. And
those would like to use upstream binary are more than capable to make their own
arrangement.

For both of these reasons, I still believe this bug should stand as NOTABUG (or
WONTFIX if you wish).

Comment 4 George Notaras 2008-06-20 05:14:15 UTC
All the above suggestions were based on the fact that Fedora's firefox package
did not catch up  with the firefox 3.0 release candidates during the last month,
so it was assumed that we would get along with the beta5 version. Apparently,
this proved not to be true, as firefox 3.0 final has been made available to
fedora users through YUM.

So, I apologize for all the waste of time :)

I understand your points and you are right.



Note You need to log in before you can comment on or make changes to this bug.